<?php

/**
 * @package     i-doit
 * @subpackage  General
 * @author      Dennis Stücken <dstuecken@i-doit.org>
 * @version     1.6
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
abstract class isys_cache_keyvalue
    extends isys_cache
    implements isys_cache_keyvaluable
{

    /**
     * Autogenerated Namespace
     *
     * @var string
     */
    protected $m_ns = '';

    /**
     * Prepend a namespace, if one exists
     *
     * @param $p_key
     *
     * @return $this
     */
    protected function prepend_ns(&$p_key)
    {
        if ($this->m_ns)
        {
            $p_key = $this->m_ns . ':' . $p_key;
        }

        return $this;
    }

    /**
     * Prepare and use a namespace
     *
     * @param string  $p_namespace
     * @param mixed   $p_value
     * @param integer $p_ttl "Time To Live" in seconds.
     *
     * @return  isys_cache_keyvalue
     */
    public function ns($p_namespace)
    {
        $this->m_ns = $this->get('caching_namespace:' . $p_namespace);

        if (!$this->m_ns)
        {
            $this->m_ns = time();
            $this->set('caching_namespace:' . $p_namespace, $this->m_ns);
        }

        return $this;
    }

    /**
     * Invalidates a namespace
     *
     * @param $p_namespace
     *
     * @return isys_cache_keyvalue
     */
    public function ns_invalidate($p_namespace)
    {
        $this->m_ns = '';

        return $this->ns($p_namespace);
    }

} // class