<?php

/**
 * i-doit
 *
 * DAO: specific category for services.
 *
 * @package     i-doit
 * @subpackage  CMDB_Categories
 * @author      Andre Woesten <awoesten@i-doit.de>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class isys_cmdb_dao_category_s_service extends isys_cmdb_dao_category_s_application
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     * @var  string
     */
    protected $m_category = 'service';

	protected $m_tpl = 'cats__application.tpl';

	protected $m_table = 'isys_cats_application_list';

	protected $m_ui = 'isys_cmdb_ui_category_s_application';

	/**
	 * Method for returning the properties.
	 *
	 * @return  array
	 * @author  Van Quyen Hoang <qhoang@i-doit.de>
	 */
	protected function properties ()
	{
		$l_properties = parent::properties();

		$l_properties['description'] = array_replace_recursive(isys_cmdb_dao_category_pattern::commentary(), array(
			C__PROPERTY__INFO => array(
				C__PROPERTY__INFO__TITLE => 'LC__CMDB__LOGBOOK__DESCRIPTION',
				C__PROPERTY__INFO__DESCRIPTION => 'Description'
			),
			C__PROPERTY__DATA => array(
				C__PROPERTY__DATA__FIELD => 'isys_cats_application_list__description'
			),
			C__PROPERTY__UI => array(
				C__PROPERTY__UI__ID => 'C__CMDB__CAT__COMMENTARY_' . C__CMDB__CATEGORY__TYPE_SPECIFIC . C__CATS__SERVICE
			)
		));

		return $l_properties;
	} // function

	/**
	 * Category entry is purgable
	 * @var bool
	 */
	protected $m_is_purgable = true;
} // class