<?php
/**
 * i-doit
 *
 * DAO: list for contract allocation
 *
 * @package i-doit
 * @subpackage CMDB_Category_lists
 * @author Van Quyen Hoang <qhoang@synetics.de>
 * @copyright synetics GmbH
 * @license http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */

class isys_cmdb_dao_list_cats_contract_allocation extends isys_cmdb_dao_list {

	/**
	 * Return constant of category
	 *
	 * @return int
	 */
	public function get_category() {
		return C__CATS__CONTRACT_ALLOCATION;
	}


	/**
	 * Return constant of category type
	 *
	 * @return int
	 */
	public function get_category_type() {
		return C__CMDB__CATEGORY__TYPE_SPECIFIC;
	}


	/**
	 * @return isys_component_dao_result
	 * @desc retrieve data for catg maintenance list view
	 */

	public function get_result($p_str = null, $p_objID, $p_cRecStatus=null) {
		return isys_factory_cmdb_category_dao::get_instance('isys_cmdb_dao_category_s_contract_allocation', $this->m_db)->get_data(null, $p_objID, '', null, ($p_cRecStatus ?: $this->get_rec_status()));
	}


	/**
	 * Returns array with table headers
	 *
	 * @return array
	 * @global $g_comp_template_language_manager
	 */
	public function get_fields() {
		return array(
			"isys_obj__id" => "ID",
			"isys_obj_type__title" => _L('LC_UNIVERSAL__OBJECT_TYPE'),
			"isys_obj__title" => _L('LC__CMDB__CATG__TITLE')
		);
	}


	public function modify_row(&$p_row) {
		$l_quick_info = new isys_ajax_handler_quick_info();
		$p_row["isys_obj__title"] = $l_quick_info->get_quick_info($p_row["isys_obj__id"], $p_row["isys_obj__title"], C__LINK__OBJECT, 80);
	}


	public function make_row_link(&$p_row) {
		return "#";
	}


	/**
	 * @param isys_cmdb_dao_category $p_cat
	 * @desc Construct the DAO object
	 */
	public function __construct(isys_cmdb_dao_category $p_cat) {
		parent::__construct($p_cat);
	}
}
?>