<?php

/**
 * i-doit
 *
 * List DAO: Cell phone.
 *
 * @package     i-doit
 * @subpackage  CMDB_Category_lists
 * @author      Leonard Fischer <lfischer@i-doit.org>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 * @since       0.9.9-9
 */
class isys_cmdb_dao_list_objects_cell_phone extends isys_cmdb_dao_list_objects
{
	/**
	 * Method for retrieving the default list query if not user defined.
	 *
	 * @return  string
	 * @author  Leonard Fischer <lfischer@i-doit.org>
	 */
	public function get_default_list_query()
	{
		return "SELECT
			obj_main.*,
			obj_main.isys_obj__id AS '__id__',
			jn3.isys_model_manufacturer__title,
			jn5.isys_model_title__title,
			j7.isys_catg_model_list__serial,
			j8.isys_cats_mobile_phone_list__imei_number,
			jn1.isys_purpose__title

			FROM isys_obj AS obj_main
			LEFT JOIN isys_cmdb_status AS obj_main_status ON obj_main_status.isys_cmdb_status__id = obj_main.isys_obj__isys_cmdb_status__id
			LEFT JOIN isys_catg_global_list AS j2 ON j2.isys_catg_global_list__isys_obj__id = obj_main.isys_obj__id
			LEFT JOIN isys_purpose AS jn1 ON jn1.isys_purpose__id = j2.isys_catg_global_list__isys_purpose__id
			LEFT JOIN isys_catg_model_list AS j7 ON j7.isys_catg_model_list__isys_obj__id = obj_main.isys_obj__id
			LEFT JOIN isys_model_manufacturer AS jn3 ON jn3.isys_model_manufacturer__id = j7.isys_catg_model_list__isys_model_manufacturer__id
			LEFT JOIN isys_model_title AS jn5 ON jn5.isys_model_title__id = j7.isys_catg_model_list__isys_model_title__id
			LEFT JOIN isys_cats_mobile_phone_list AS j8 ON j8.isys_cats_mobile_phone_list__isys_obj__id = obj_main.isys_obj__id

			WHERE (obj_main.isys_obj__isys_obj_type__id = " . $this->convert_sql_id(C__OBJTYPE__CELL_PHONE_CONTRACT) . ") ";
	} // function


	/**
	 * Method for retrieving the default JSON encoded array of the property-selector.
	 *
	 * @return  string
	 * @author  Leonard Fischer <lfischer@i-doit.org>
	 */
	public function get_default_list_config()
	{
		return '[[' . C__PROPERTY_TYPE__DYNAMIC . ',"_id",false,"LC__CMDB__OBJTYPE__ID","isys_cmdb_dao_category_g_global::get_dynamic_properties",["isys_cmdb_dao_category_g_global","dynamic_property_callback_id"]],' .
			'[' . C__PROPERTY_TYPE__DYNAMIC . ',"_title",false,"LC__UNIVERSAL__TITLE_LINK","isys_cmdb_dao_category_g_global::get_dynamic_properties",["isys_cmdb_dao_category_g_global","dynamic_property_callback_title"]],' .
			'[' . C__PROPERTY_TYPE__STATIC . ',"manufacturer","isys_model_manufacturer__title","LC__CATG__STORAGE_MANUFACTURER","isys_cmdb_dao_category_g_model::get_properties",false],' .
			'[' . C__PROPERTY_TYPE__STATIC . ',"title","isys_model_title__title","LC__CMDB__CATG__MODEL","isys_cmdb_dao_category_g_model::get_properties",false],' .
			'[' . C__PROPERTY_TYPE__STATIC . ',"serial","isys_catg_model_list__serial","LC__CMDB__CATG__SERIAL","isys_cmdb_dao_category_g_model::get_properties",false],' .
			'[' . C__PROPERTY_TYPE__STATIC . ',"imei_number","isys_cats_mobile_phone_list__imei_number","LC__CMDB__CATS__SIM_CARD__IMEI_NUMBER","isys_cmdb_dao_category_s_cp_contract::get_properties",false],' .
			'[' . C__PROPERTY_TYPE__DYNAMIC . ',"_created",false,"LC__TASK__DETAIL__WORKORDER__CREATION_DATE","isys_cmdb_dao_category_g_global::get_dynamic_properties",["isys_cmdb_dao_category_g_global","dynamic_property_callback_created"]],' .
			'[' . C__PROPERTY_TYPE__DYNAMIC . ',"_changed",false,"LC__CMDB__LAST_CHANGE","isys_cmdb_dao_category_g_global::get_dynamic_properties",["isys_cmdb_dao_category_g_global","dynamic_property_callback_changed"]],' .
			'[' . C__PROPERTY_TYPE__STATIC . ',"purpose","isys_purpose__title","LC__CMDB__CATG__GLOBAL_PURPOSE","isys_cmdb_dao_category_g_global::get_properties",false],' .
			'[' . C__PROPERTY_TYPE__DYNAMIC . ',"_cmdb_status",false,"LC__UNIVERSAL__CMDB_STATUS","isys_cmdb_dao_category_g_global::get_dynamic_properties",["isys_cmdb_dao_category_g_global","dynamic_property_callback_cmdb_status"]]]';
	} // function
} // class