<?php

namespace idoit\Module\Cmdb\Model\Ci\Category\G\Livestatus;

use idoit\Module\Cmdb\Model\Ci\Category\DynamicCallbackInterface;

/**
 * i-doit
 *
 * Livestatus Category "Livestatus State Button" callback.
 *
 * @package     i-doit
 * @subpackage  Cmdb
 * @author      Van Quyen Hoang <qhoang@i-doit.com>
 * @version     1.8
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class LivestatusStateButton implements DynamicCallbackInterface
{
    /**
     * Render method.
     *
     * @param string $data
     * @param mixed  $extra
     *
     * @return mixed
     */
    public static function render($data, $extra = null)
    {
        if (!$data)
        {
            return '';
        } // if

        global $g_dirs;

        return '<button type="button" class="btn btn-small" data-action="load-livestatus-state" data-object-id="' . $data . '">' .
        '<img src="' . $g_dirs['images'] . 'icons/silk/arrow_right.png" class="mr5" /><span>' . _L('LC__UNIVERSAL__LOAD') . '</span>' .
        '</button>';
    } // function
} // class