var g_onload_callbacks = [];
var g_droppables = [];
var drags = [];
var dragging = false;

/**
 * Removes currently initialized Droppables
 */
function remove_drops() {
    if (typeof drops == 'object')
    {
        g_droppables.each(function (drop, k) {
            if (drop)
            {
                Droppables.remove(drop);
                drops.splice(k, 1);
            }
        });
        drags = [];
        drops = [];
        g_droppables = [];
    }
}

/**
 * Removes currently initialized Draggables
 */
function remove_drags() {
    drags.each(function (drag, k) {
        if (drag)
        {
            drag.destroy();
        }
    });
    drags = [];
}

/**
 * Initialize Droppables
 * @uses drops, drags
 */
function init_drops() {
    if (typeof drops == 'object')
    {
        drops.each(function (drop) {
            if ($('smenu_tree' + drop.nodeid))
            {
                g_droppables.push('smenu_tree' + drop.nodeid);

                Droppables.add('smenu_tree' + drop.nodeid,
                    {
                        accept:     'draggable',
                        hoverclass: 'hover',
                        onDrop:     function () {
                            var $dragGhost = $('body').down('.mainTableDragGhost'),
                                draggedIDs = $dragGhost.readAttribute('data-ids').split(','),
                                $originTable = $($dragGhost.readAttribute('data-table-id'));

                            if (!$dragGhost)
                            {
                                return;
                            }

                            draggedIDs.filter(function(id){
                                return ! isNaN(parseInt(id));
                            });

                            if (! draggedIDs.length) {
                                idoit.Notify.error('Please try again!', {life:5});
                                return;
                            }

                            new Ajax.Request(
                                '?ajax=1&call=change_object_type',
                                {
                                    parameters: {
                                        objTypeID: drop.id,
                                        objID:     draggedIDs.join(',')
                                    },
                                    method:     'post',
                                    onComplete: function (xhr) {
                                        var json = xhr.responseJSON;

                                        if (json.success)
                                        {
                                            if ($originTable)
                                            {
                                                $originTable.fire('remove:entriesByIds', {ids: $dragGhost.readAttribute('data-ids').split(',')});
                                            }

                                            $('infoBox').update(json.data).highlight();
                                        }
                                        else
                                        {
                                            idoit.Notify.error(json.message, {sticky: true});
                                        }
                                    }.bind(this)
                                });
                        }
                    });
            }
        });
    }
}

/**
 * Adds a callback to the body-onload handler
 *
 * @return void
 * @param string p_functioncall
 */
function onload_add_callback(p_functioncall) {
    g_onload_callbacks.push(p_functioncall);
}

/**
 * Processes the list of callbacks
 *
 * @return void
 */
function onload_process() {
    if (g_onload_callbacks)
    {
        for (i = 0; i < g_onload_callbacks.length; i++)
        {
            eval(g_onload_callbacks[i]);
        }
    }

    // AJAX History.
    History.init();
}