/**
 * Method for calculating the missing value.
 *
 * @param    $volt
 * @param    $watt
 * @param    $ampere
 * @returns  void
 */
function vwa_autocalc($volt, $watt, $ampere) {
	var vals = {
		volt: $volt.getValue(),
		watt: $watt.getValue(),
		ampere: $ampere.getValue()
	};

	if (isNaN(vals.volt) || isNaN(vals.watt) || isNaN(vals.ampere)) {
		return;
	}

	if (!vals.volt.blank() && !vals.watt.blank() && !vals.ampere.blank()) {
		return;
	}

	if (vals.volt.blank() && !vals.watt.blank() && !vals.ampere.blank()) {
		$volt.setValue(vals.watt / vals.ampere);
	}

	if (!vals.volt.blank() && vals.watt.blank() && !vals.ampere.blank()) {
		$watt.setValue(vals.volt * vals.ampere);
	}

	if (!vals.volt.blank() && !vals.watt.blank() && vals.ampere.blank()) {
		$ampere.setValue(vals.watt / vals.volt);
	}
}