<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.7
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */
 trait isys_settings_trait { protected static $m_cachefile = 'settings.cache'; protected static $m_cache_dir = ''; protected static $m_initialized = false; protected static $m_settings = []; private static $m_changed = false; public static function get_definition() { return self::$m_definition; } public static function extend(array $p_settings = []) { self::$m_definition += $p_settings; } public static function is_initialized() { return self::$m_initialized; } public static function load_cache($p_cachedir) { if (file_exists($p_cachedir . self::$m_cachefile)) { if (is_readable($p_cachedir . self::$m_cachefile)) { self::$m_settings = self::decode(file_get_contents($p_cachedir . self::$m_cachefile)); } else { throw new isys_exception_filesystem($p_cachedir . self::$m_cachefile . ' not readable'); } } else { throw new isys_exception_filesystem('Error: Cache file ' . $p_cachedir . self::$m_cachefile . ' does not exist'); } } public static function set($p_key, $p_value) { self::$m_changed = true; if (!isset(self::$m_settings[$p_key])) { self::$m_dao->set($p_key, $p_value) ->apply_update(); } self::$m_settings[$p_key] = $p_value; } public static function remove($p_key) { unset(self::$m_settings[$p_key]); self::$m_dao->remove($p_key); } public static function get($p_key = null, $p_default = '') { if ($p_key === null) { return self::$m_settings; } return isset(self::$m_settings[$p_key]) && self::$m_settings[$p_key] !== '' ? self::$m_settings[$p_key] : $p_default; } public static function has($p_key) { return isset(self::$m_settings[$p_key]); } public static function override(array $p_settings) { self::$m_settings = $p_settings; self::cache(); self::$m_dao->save($p_settings, false); } public static function force_save() { self::cache(); self::$m_dao->save(self::$m_settings); } public static function shutdown() { if (self::$m_changed) { self::force_save(); } } protected static function get_cache_dir() { return isys_application::instance()->app_path . '/temp/' . self::$m_cache_dir; } protected static function cache() { try { self::write(self::get_cache_dir() . self::$m_cachefile, self::$m_settings); } catch (Exception $e) { throw $e; } } protected static function write($p_file, $p_settings) { if (!file_exists($p_file)) { if (!is_dir(dirname($p_file))) { if (!mkdir(dirname($p_file), 0777, true)) { throw new isys_exception_cache('Error writing settings cache directory: ' . dirname($p_file) . ' could not be written.', 'Settings'); } } if (is_writable(dirname($p_file))) { touch($p_file); chmod($p_file, 0777); } else { throw new isys_exception_cache('Error writing settings cache: ' . $p_file . ' is not writeable.', 'Settings'); } } if (is_writeable($p_file)) { file_put_contents($p_file, self::encode($p_settings)); } else { throw new isys_exception_filesystem('Error writing settings cache: ' . $p_file . ' is not writeable.'); } } protected static function encode($p_data) { return isys_format_json::encode($p_data); } protected static function decode($p_data) { return isys_format_json::decode($p_data, true); } }