<?php

/**
 * i-doit APi
 *
 * @package    i-doit
 * @subpackage API
 * @author     Dennis Stücken <dstuecken@synetics.de>
 * @copyright  synetics GmbH
 * @license    http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class isys_api_model_idoit_search
    implements isys_api_model_interface
{

    /**
     * @param array $p_params
     *
     * @return array
     */
    public function read($p_params)
    {
        if (!isset($p_params['q']))
        {
            throw new isys_exception_api('Missing parameter: "q".', -32601);
        }

        $manager = \idoit\Module\Search\Query\QueryManager::factory()
                                                          ->attachEngine(
                                                              new \idoit\Module\Search\Query\Engine\Mysql\SearchEngine()
                                                          )
                                                          ->addSearchKeyword($p_params['q']);

        $queryResult = $manager->search();
        $result      = $queryResult->getResult();

        return $result;
    } // function

    /**
     * Constructor
     */
    public function __construct()
    {

    } // function

} // class