<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.7
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */
namespace idoit\Module\Cmdb\Model\Matcher\Ci; use idoit\Module\Cmdb\Model\Matcher\AbstractMatcher; use idoit\Module\Cmdb\Model\Matcher\Match; use idoit\Module\Cmdb\Model\Matcher\MatchConfig; use idoit\Module\Cmdb\Model\Matcher\Protocol\Matchable; class CiMatcher extends AbstractMatcher implements Matchable { protected $identifiers; public function match(array $matchKeywords) { $unionSelect = ''; $objectid = null; $title = null; $minMatch = $this->config->getMinMatch(); $matchResult = []; foreach ($matchKeywords as $keyword) { if ($this->identifiers->hasIdentifier($keyword->getKey())) { $identifier = $this->identifiers->getIdentifier($keyword->getKey()); $value = $keyword->getValue(); $condition = $keyword->getCondition(); if($value) { $unionSelect .= $identifier->getSqlSelect($value, $condition) . ' UNION '; } } } $unionSelect = 'SELECT *, count(matchblock.id) AS matchings FROM (' . rtrim($unionSelect, ' UNION ') . ') AS matchblock GROUP BY id HAVING matchings > 0 ORDER BY matchings DESC LIMIT 3'; $resultSet = $this->config->getDao()->retrieve($unionSelect); $matchCount = $resultSet->count(); while($row = $resultSet->get_row()) { if(!$objectid && $row['matchings'] >= $minMatch) { $objectid = $row['id']; $title = $row['title']; } $matchResult[] = Match::factory() ->setId($row['id']) ->setTitle($row['title']); } return Match::factory() ->setId($objectid) ->setTitle($title) ->setMatchResult($matchResult) ->setMatchCount($matchCount); } public function __construct(MatchConfig $config) { parent::__construct($config); $this->identifiers = new CiIdentifiers($config->getBits()); } }