<?php

/**
 * i-doit
 *
 * UI: global category for custom identifiers
 *
 * @package     i-doit
 * @subpackage  CMDB_Categories
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 * @author      Selcuk Kekec <skekec@i-doit.com>
 */
class isys_cmdb_ui_category_g_identifier extends
    isys_cmdb_ui_category_global
{
    /**
     * Process ui rules
     *
     * @param \isys_cmdb_dao_category $p_cat
     *
     * @return array
     * @throws \isys_exception_dao_cmdb
     * @author Selcuk Kekec <skekec@i-doit.com>
     */
    public function process (isys_cmdb_dao_category $p_cat)
    {
        global $g_loc;

        // Get rules
        $l_rules = parent::process($p_cat); // TODO: Change the autogenerated stub

        // Reformat field 'last_edited'
        if (isset($l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue']) &&
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue'] != '' &&
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue'] != '1970-01-01 01:00:00')
        {
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue'] = $g_loc->fmt_datetime($l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue'], true, false);
        }
        else
        {
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_EDITED']['p_strValue'] = '-';
        } // if

        if (isset($l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue']) &&
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'] != '' &&
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'] != '-' &&
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'] != '1970-01-01 01:00:00')
        {
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'] = $g_loc->fmt_datetime(date('Y-m-d H:i:s', strtotime($l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'])), true, false);
        }
        else
        {
            $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_SCAN']['p_strValue'] = '-';
        } // if

        $l_rules['C__CMDB__CATG__IDENTIFIER__LAST_UPDATED']['p_strValue'] = $g_loc->fmt_datetime($l_rules['C__CMDB__CATG__IDENTIFIER__LAST_UPDATED']['p_strValue'], true, false);

        // Reset rules
        $this
            ->get_template_component()
            ->smarty_tom_add_rules('tom.content.bottom.content', $l_rules);

        return $l_rules;
    } // function

} // class