<?php
namespace idoit\Component\Provider;

use idoit\Component\ContainerFacade;
use isys_application as Application;

/**
 * i-doit Container Aware Trait
 *
 * @package     i-doit
 * @subpackage  Component
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
trait DiInjectable
{
    /**
     * @var ContainerFacade
     */
    protected $container;

    /**
     * @param ContainerFacade $container
     *
     * @return mixed
     */
    public function setDi(ContainerFacade $container)
    {
        $this->container = $container;
    }

    /**
     * @return ContainerFacade
     */
    public function getDi()
    {
        if (!$this->container)
        {
            $this->container = Application::instance()->container;
        }

        return $this->container;
    }

}