<?php
/**
 * i-doit - Updates
 * This migration resets the object list for the object type "CABLE"
 *
 * @package     i-doit
 * @subpackage  Update
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 * @author      Van Quyen Hoang <qhoang@i-doit.com>
 */

// Initialization
global $g_comp_database, $g_comp_database_system;

$g_migration_identifier = "migration_reset_object_list_cable";

if ($this->is_migration_done($g_migration_identifier))
{
	$g_migration_log[] = "<span class=\"bold grey indent\">Reset of the object list for 'Cable' has already been executed.</span>";
}
else
{
	try
	{
		$l_dao = new isys_cmdb_dao_list_objects_cable($g_comp_database);

		$l_sql = 'SELECT isys_obj_type_list__id AS id FROM isys_obj_type_list WHERE isys_obj_type_list__isys_obj_type__id = ' . $l_dao->convert_sql_id(C__OBJTYPE__CABLE);
		$l_res = $l_dao->retrieve($l_sql);
		if ($l_res->num_rows() > 0)
		{
			$l_id = $l_res->get_row_value('id');
			$g_migration_log[] = "<span class='bold'>Object list for object type 'Cable' found. Resetting object list ...</span>";
			$l_config = $l_dao->get_default_list_config();
			$l_query = $l_dao->get_default_list_query();

			$l_update = 'UPDATE isys_obj_type_list SET '.
				'isys_obj_type_list__query = ' . $l_dao->convert_sql_text($l_query) . ', ' .
				'isys_obj_type_list__config = ' . $l_dao->convert_sql_text($l_config) . ' ' .
				'WHERE isys_obj_type_list__id = ' . $l_dao->convert_sql_id($l_id);
			$l_dao->update($l_update);
			$l_dao->apply_update();
		}
		else
		{
			$g_migration_log[] = '<span class="bold">Object list for object type "Cable" not found. Skipping migration.</span>';
		} // if

		// Set flag in db.
		$this->migration_done($g_migration_identifier);

		$g_migration_log[] = "<span class=\"bold\">Migration successful.</span>";
	}
	catch (Exception $e)
	{
		$g_migration_log[] = "<span class=\"bold red\">" . $e->getMessage() . "</span>";
	} // try
} // if