<?php
/**
 * i-doit - Updates
 * This migration fixes secondary and primary software assignments
 *
 * @package     i-doit
 * @subpackage  Update
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 * @author      Dennis Stücken
 */

// Initialization
global $g_comp_database;

$g_migration_identifier = "migration_primary_secondary_os";

if ($this->is_migration_done($g_migration_identifier))
{
	$g_migration_log[] = '<span class="bold grey indent">OS migration has already been executed.</span>';
}
else
{
	try
	{
        $g_migration_log[] = '<span class="bold">Starting OS migration (for incorrect primary/secondary entries).</span>';

        $g_comp_database->begin();

		$latestOS = $g_comp_database->query("SELECT isys_catg_application_list__id
   FROM isys_catg_application_list
   LEFT JOIN isys_catg_application_type ON isys_catg_application_type__id = isys_catg_application_list__isys_catg_application_type__id
   LEFT JOIN isys_catg_application_priority ON isys_catg_application_priority__id = isys_catg_application_list__isys_catg_application_priority__id
   WHERE (isys_catg_application_priority__const = 'C__CATG__APPLICATION_PRIORITY__SECONDARY'
          OR ISNULL(isys_catg_application_priority__const))
     AND isys_catg_application_type__const = 'C__CATG__APPLICATION_TYPE__OPERATING_SYSTEM'
   GROUP BY isys_catg_application_list__isys_obj__id
   ORDER BY isys_catg_application_list__id DESC;");

        while ($row = $g_comp_database->fetch_row_assoc($latestOS))
        {
            $g_comp_database->query("UPDATE isys_catg_application_list allSoftware
SET allSoftware.isys_catg_application_list__isys_catg_application_priority__id =
  (SELECT isys_catg_application_priority__id
   FROM isys_catg_application_priority
   WHERE isys_catg_application_priority__const = 'C__CATG__APPLICATION_PRIORITY__PRIMARY')
WHERE allSoftware.isys_catg_application_list__id = ".$row['isys_catg_application_list__id']."
  OR isys_catg_application_list__isys_catg_application_type__id IS NULL;");
        }

        $g_comp_database->commit();

		// Set flag in db.
		$this->migration_done($g_migration_identifier);

		$g_migration_log[] = '<span class="bold">Migration successful ('.$g_comp_database->num_rows($latestOS).' entries affected).</span>';
	}
	catch (Exception $e)
	{
		$g_migration_log[] = '<span class="bold red">' . $e->getMessage() . '</span>';
	} // try
} // if