<?php

/**
 * i-doit
 *
 * Factory for CMDB DAOs
 *
 * @package     i-doit
 * @subpackage  CMDB_Categories
 * @author      Dennis Stücken <dstuecken@synetics.de>
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
class isys_factory_cmdb_dao extends isys_factory
{
    /**
     * Gets an instance of a CMDB DAO.
     *
     * @param   string                  $p_class
     * @param   isys_component_database $p_db
     *
     * @return  isys_cmdb_dao
     */
    public static function get_instance($p_class, isys_component_database $p_db)
    {
        if (!isset(self::$m_instances[$p_class]))
        {
            self::$m_instances[$p_class] = new $p_class($p_db);
        } //if

        return self::$m_instances[$p_class];
    } // function
} // class