<?php
namespace idoit\Module\Search\Index\Protocol;

/**
 * i-doit
 *
 * Search document
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.7
 * @copyright   synetics GmbH
 * @license     http://www.gnu.org/licenses/agpl-3.0.html GNU AGPLv3
 */
interface Document
{

    /**
     * Documents data.
     *
     * Plain key => value array structure.
     *
     * e.g. ['cpu.1.frequency' => 2127, 'cpu.1.title' => 'Xeon E7430']
     *
     * @return array
     */
    public function getData();

    /**
     * Documents id. (Object ID for CMDB indexes)
     *
     * @return int
     */
    public function getId();

    /**
     * Document title. (Object title for CMDB indexes)
     *
     * @return string
     */
    public function getTitle();

    /**
     * The Module of this search document. E.g. cmdb, or viva.
     *
     * @return string
     */
    public function getType();

}