<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.7
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */
namespace idoit\Component\Table; use idoit\Component\Table\Pagerfanta\View\IdoitView; use Pagerfanta\Adapter\AdapterInterface; use Pagerfanta\Pagerfanta; class Table { const CURRENT_PAGE = 'page'; protected $header; protected $adapter; protected $pager; protected $template; protected $options = [ 'enableCheckboxes' => false, 'rowClick' => false, 'rowClickURL' => null, 'keyboardCommands' => false, 'tableConfigURL' => null, 'dragDrop' => false, 'filter' => false, 'filterColumns' => [], 'resizeColumns' => false, 'resizeColumnAjaxURL' => null, 'columnSizes' => [], 'pages' => 0, 'rowsPerPage' => 50 ]; protected $unique; public static function factory(AdapterInterface $adapter, array $header, array $options = []) { return new static($adapter, $header, $options); } public function __construct(AdapterInterface $adapter, array $header, array $options = []) { global $g_dirs; $this->header = $header; $this->adapter = $adapter; $this->pager = new Pagerfanta($adapter); $this->template = $g_dirs['smarty'] . 'templates/content/bottom/content/component_table.tpl'; $this->options = array_replace_recursive($this->options, $options); $this->unique = uniqid('mainTable-'); $this->initializePager($_GET[self::CURRENT_PAGE], $this->options['rowsPerPage']); } public function getPager() { return $this->pager; } public function getUnique() { return $this->unique; } public function initializePager($currentPage = null, $entriesPerPage = null) { if ($currentPage === null) { $currentPage = 1; } if ($entriesPerPage === null) { $entriesPerPage = isys_glob_get_pagelimit(); } $this->pager->setCurrentPage($currentPage) ->setMaxPerPage($entriesPerPage); return $this; } public function render($return = false) { global $g_dirs; $rowsPerPageOnLastPage = $pagerNextUrl = null; $rowPerPage = \isys_usersettings::get('gui.objectlist.rows-per-page', 50); $rows = $this->pager->getNbResults(); $routeGenerator = function ($page) { $url = []; parse_str($_SERVER['QUERY_STRING'], $url); $url[self::CURRENT_PAGE] = $page; unset($url[C__GET__AJAX]); return '?' . http_build_query($url); }; $pagerView = (new IdoitView())->render( $this->pager, $routeGenerator, [ 'proximity' => 3, 'previous_message' => '<img src="' . $g_dirs['images'] . 'icons/silk/resultset_previous.png" alt="<" />', 'next_message' => '<img src="' . $g_dirs['images'] . 'icons/silk/resultset_next.png" alt=">" />', 'container_template' => _L('LC__UNIVERSAL__PAGES') . ' %pages%' ] ); $callbacks = []; $data = $this->pager->getCurrentPageResults(); if (is_array($data) && count($data)) { foreach ($data[0] as $key => $value) { list($class, $property) = explode('__', str_replace('isys_cmdb_dao_category_', '', $key)); $class = str_replace(' ', '', ucwords(str_replace('_', ' ', $class))); $property = str_replace(' ', '', ucwords(str_replace('_', ' ', $property))); $callbackClass = '\\idoit\\Module\\Cmdb\\Model\\Ci\\Category\\' . substr($class, 0, 1) . '\\' . substr($class, 1) . '\\' . $property; if (! empty($class) && class_exists($callbackClass) && is_a($callbackClass, 'idoit\\Module\\Cmdb\\Model\\Ci\\Category\\DynamicCallbackInterface', true)) { $callbacks[$key] = $callbackClass; } } foreach ($data as &$row) { foreach ($row as $key => &$value) { if (strpos($key, '__') === false && strpos($key, '###') === false && $key != '__id__') { unset($row[$key]); continue; } $value = _LL($value); if (isset($callbacks[$key])) { $value = call_user_func($callbacks[$key] . '::render', $value); } } } } else { $data = []; } $rowsPerPage = array_unique([ 50 => '50', 100 => '100', 150 => '150', 200 => '200', 250 => '250', 500 => '500', (int) $rowPerPage => $rowPerPage ]); if (! $this->pager->hasNextPage()) { $rowsPerPageOnLastPage = count($data); $rowsPerPage[$rowsPerPageOnLastPage] = $rowsPerPageOnLastPage; foreach ($rowsPerPage as $rowCount => $rowName) { if ($rowsPerPageOnLastPage < $rowCount) { unset($rowsPerPage[$rowCount]); } } } else { $pagerNextUrl = $routeGenerator($this->pager->getNextPage()); } natsort($rowsPerPage); if ($rows <= \isys_tenantsettings::get('cmdb.limits.table-order-threshhold', 20000)) { $rowsPerPage[$rows] = _L('LC__UNIVERSAL__ALL'); } $rules = [ $this->unique . '-filter' => [ 'disableInputGroup' => true, 'p_bInfoIconSpacer' => 0, 'p_strValue' => $this->options['filterDefaultValue'] ], $this->unique . '-filter-field' => [ 'disableInputGroup' => true, 'p_bDbFieldNN' => true, 'p_bSort' => false, 'p_bInfoIconSpacer' => 0, 'p_arData' => $this->options['filterColumns'], 'p_strSelectedID' => $this->options['filterDefaultColum'] ], $this->unique . '-rows-per-page' => [ 'disableInputGroup' => true, 'p_bDbFieldNN' => true, 'p_bSort' => false, 'p_bInfoIconSpacer' => 0, 'p_arData' => $rowsPerPage, 'p_strSelectedID' => (int) $rowsPerPageOnLastPage ?: $this->options['rowsPerPage'] ] ]; if (!isset($this->options['pages']) || !$this->options['pages']) { $this->options['pages'] = $this->pager->getNbPages(); } unset($_GET[C__GET__AJAX], $_GET[C__GET__AJAX_CALL]); $tpl = \isys_application::instance()->template->activate_editmode() ->assign('unique', $this->unique) ->assign('header', $this->header) ->assign('data', $data) ->assign('pager', $pagerView) ->assign('pagerUrl', $routeGenerator('%page%')) ->assign('pagerCurrentUrl', $routeGenerator($this->pager->getCurrentPage())) ->assign('pagerNextUrl', $pagerNextUrl) ->assign('rows', $rows) ->assign('options', $this->options) ->smarty_tom_add_rules('tom.content.table', $rules); if (!$return) { $tpl->display($this->template); } return $tpl->fetch($this->template); } } 